Google Web Toolkit (Beta)
Search this site:

# Class GWT

public final class GWT
extends Object
Supports core functionality that in some cases requires direct support from the compiler and runtime systems such as runtime type information and deferred binding.

## Nested Interfaces

GWT.UncaughtExceptionHandler | This interface is used to catch exceptions at the "top level" just before they escape to the browser.

## Methods

create(Class) | Instantiates a class via deferred binding.
getHostPageBaseURL() | Gets the URL prefix of the hosting page, useful for prepending to relative paths of resources which may be relative to the host page.
getModuleBaseURL() | Gets the URL prefix of the module which should be prepended to URLs that are intended to be module-relative, such as RPC entry points and files in the module's public path.
getModuleName() | Gets the name of the running module.
getTypeName(Object) | Gets the class name of the specified object, as would be returned by `o.getClass().getName()`.
getUncaughtExceptionHandler() | Returns the currently active uncaughtExceptionHandler.
isScript() | Determines whether or not the running program is script or bytecode.
log(String, Throwable) | Logs a message to the development shell logger in hosted mode.
setUncaughtExceptionHandler(GWT.UncaughtExceptionHandler) | Sets a custom uncaught exception handler.

## Method Detail

### create

public static Object create(Class classLiteral)
Instantiates a class via deferred binding.

The argument to create(Class) must be a class literal because the web mode compiler must be able to statically determine the requested type at compile-time. This can be tricky because using a Class variable may appear to work correctly in hosted mode.

#### Parameters

classLiteral
  a class literal specifying the base class to be instantiated

#### Return Value

the new instance, which must be typecast to the requested class.

### getHostPageBaseURL

public static String getHostPageBaseURL()
Gets the URL prefix of the hosting page, useful for prepending to relative paths of resources which may be relative to the host page. Typically, you should use getModuleBaseURL() unless you have a specific reason to load a resource relative to the host page.

#### Return Value

if non-empty, the base URL is guaranteed to end with a slash

### getModuleBaseURL

public static String getModuleBaseURL()
Gets the URL prefix of the module which should be prepended to URLs that are intended to be module-relative, such as RPC entry points and files in the module's public path.

#### Return Value

if non-empty, the base URL is guaranteed to end with a slash

### getModuleName

public static String getModuleName()
Gets the name of the running module.

### getTypeName

public static String getTypeName(Object o)
Gets the class name of the specified object, as would be returned by `o.getClass().getName()`.

#### Parameters

o
  the object whose class name is being sought, or `null`

#### Return Value

the class name of the specified object, or `null` if `o` is `null`

### getUncaughtExceptionHandler

public static GWT.UncaughtExceptionHandler getUncaughtExceptionHandler()
Returns the currently active uncaughtExceptionHandler. "Top level" methods that dispatch events from the browser into user code must call this method on entry to get the active handler. If the active handler is null, the entry point must allow exceptions to escape into the browser. If the handler is non-null, exceptions must be caught and routed to the handler. See the source code for `DOM.dispatchEvent()` for an example of how to handle this correctly.

#### Return Value

the currently active handler, or null if no handler is active.

### isScript

public static boolean isScript()
Determines whether or not the running program is script or bytecode.

### log

public static void log(String message, Throwable e)
Logs a message to the development shell logger in hosted mode. Calls are optimized out in web mode.

#### Parameters

message
e

### setUncaughtExceptionHandler

public static void setUncaughtExceptionHandler(GWT.UncaughtExceptionHandler handler)
Sets a custom uncaught exception handler. See getUncaughtExceptionHandler() for details.

#### Parameters

handler
  the handler that should be called when an exception is about to escape to the browser, or `null` to clear the handler and allow exceptions to escape.